function love.load()

	if love.filesystem.isFile("/bgmusic.mp3") then
		testM = love.audio.newSource("/bgmusic.mp3")
		testMS = testM:getDuration("seconds")
		nofile = false
	else
		nofile = true
	end
	play = false
	lineoffset = 20
	width, height = love.graphics.getDimensions()
	scale = 13.5
	yaxis = 300
	
	dir = love.filesystem.getSaveDirectory()
	
	f = love.filesystem.newFile("notes.txt")
	
	f:open("w")
	
	noteoff = 0.4
	
	log1 = {}
	
	timer = 0
	
end

function love.draw()
	if nofile == false then
	love.graphics.line(testM:tell()*scale+lineoffset,yaxis,testM:tell()*scale+lineoffset,yaxis+50)
	love.graphics.print(testM:tell(),testM:tell()*scale+lineoffset,yaxis-20)
	
	love.graphics.line(lineoffset,yaxis+25,testMS*scale+lineoffset,yaxis+25)
	
	love.graphics.print("Save directory: "..dir)
	
	for i, v in ipairs(log1) do
		love.graphics.print("Added note at "..v.time.." seconds. Type "..v.num,0,15*i)
	end
	else
		love.graphics.print("Umm... Hey so, there's no mp3 file to open, so whatcha gonna do?")
	end
end

function love.update(dt)
	if nofile == false then
	if love.keyboard.isDown("down") and testM:tell() > 0.1 then
		testM:seek(testM:tell()-0.1,"seconds")
	end
	if love.keyboard.isDown("up") and testM:tell() < testMS-0.1 then
		testM:seek(testM:tell()+0.1,"seconds")
	end
	if #log1 > 0 then
		timer = timer + 1
		if timer > 100 then
			table.remove(log1,1)
			timer = 0
		end
	end
	end
end

function love.keypressed(key)
	if key == "escape" then
		f:close()
		love.event.quit()
	end
	if nofile == false then
	if key == "space" then
		if play then
			testM:pause()
			play = false
		else
			testM:play()
			play = true
		end
	end
	if key == "1" then
		f:write("|T-"..testM:tell()-noteoff.."|1|\r\n")
		table.insert(log1,noteAdd(1))
	end
	if key == "2" then
		f:write("|T-"..testM:tell()-noteoff.."|2|\r\n")
		table.insert(log1,noteAdd(2))
	end
	if key == "3" then
		f:write("|T-"..testM:tell()-noteoff.."|3|\r\n")
		table.insert(log1,noteAdd(3))
	end
	if key == "4" then
		f:write("|T-"..testM:tell()-noteoff.."|4|\r\n")
		table.insert(log1,noteAdd(4))
	end
	if key == "a" then
		table.insert(log1,noteAdd(1))
	end
	if key == "left" and testM:tell() > 0.25 then
		testM:seek(testM:tell()-0.25,"seconds")
	end
	if key == "right" and testM:tell() < testMS-0.25 then
		testM:seek(testM:tell()+0.25,"seconds")
	end
	if key == "c" then
		love.system.setClipboardText(dir)
	end
	end
end

function noteAdd(num)
	local v = {}
	v.time = testM:tell()
	v.num = num
	return v
end